# DESTINATION:                         PRZEZNACZENIE:
#  This is an auxiliary AWK program  |  To jest skrypt AWK-owy, zamieniaj/acy
#  for converting a TFM file into    |  plik metryczny TFM na font wirtualny;
#  a virtual font to be used along   |  skrypt ten jest przeznaczony do
#  with TOIL (an AWK-based           |  wykorzystania z pakietem TOIL
#  PostScript font installer         |  (bazuj/acym na AWK-u), s/lu/z/acym do
#  for TeX).                         |  instalowania font/ow postscriptowych
#                                    |  dla TeX-a.
#
# STATUS:
#   Public domain                    | Dobro wsp/olne
#   prepared in BOP                  | przygotowano w firmie BOP
#   e-mail contact:                  | kontakt elektroniczny:
#                       B.Jackowski@GUST.org.pl
#
# VERSION:                           | WERSJA:
#                     0.50, 1 V 1999, BachoTeX, Poland
#
# SYNOPSIS:                            OPIS:
#  The source is a property list     |  Na wej/sciu oczekiwany jest plik
#  for a given font (the output      |  PL (property list) b/ed/acy
#  from a TFTOPL program) and        |  wynikiem dzia/lania programu
#  the result is a virtual           |  TFTOPL; na wyj/sciu tworzony jest
#  property list (the input for      |  plik VPL (virtual property list)
#  a VPTOVL program). The resulting  |  stanowi/acy dane wej/sciowe
#  virtual font is nearly equivalent |  dla programu VPTOVF. Wynikowy
#  to the original one, except       |  font wirtualny jest niemal
#  that the character of a given     |  r/ownowa/zny oryginalnemu, z tym
#  code (parameter DC) becomes       |  wyj/atkiem, /ze okre/slony za
#  dummy, i.e., all its typesetting  |  pomoc/a parametru DC znak staje si/e
#  commands are erased -- it is      |  pusty, tzn. usuwane s/a ze/n
#  supposed to be an artificial      |  instrukcje sk/ladaj/ace; zak/lada
#  `boundary' character added by     |  si/e, /ze jest to znak sztucznie
#  TOIL when used with option `-b'.  |  do/l/aczony przez program TOIL jako
#  There is one more option,         |  tzw. znak brzegowy (opcja `-b').
#  admittedly idiosyncratic:         |  Dodatkowa specyficzna opcja pozwala
#  uppercasing the original font     |  na wymuszenie du/zych liter w nazwie
#  name; namely, if UN parameter     |  oryginalnego fontu -- je/sli parametr
#  is not empty, the font name       |  UN jest niepusty, to litery w nazwie
#  gets uppercased, otherwise        |  s/a zamieniane na du/ze, w przeciwnym
#  it is left intact.                |  razie nazwa nie ulega zmianie.
#
BEGIN {
# DC -- dummy character (optional parameter)
# UN -- uppercase font name
  for (i=65; i<=90; i+=1) uc_tab[sprintf("%c",i+32)]=sprintf("%c",i)
  for (i=0; i<=255; i+=1) cc[sprintf("%c",i)]=i
}

/^[^ \t]+/ && (NR==1) {
  print "(VTITLE )"; font_name=FILENAME
  if (UN!="") font_name=uc(font_name)
  gsub(/^.*[\\:]/,"", font_name)  # truncate directory
  gsub(/\.[^\.]*$/,"", font_name) # truncate extension
}

/^\(DESIGNSIZE/ {design_size=$0; sub("DESIGN", "FONTD", design_size)}
/^\(CHECKSUM/ {check_sum=$0; sub("CHECK", "FONTCHECK", check_sum)}
/^\(FONTDIMEN/, /^[\t ]*)$/ {if (/^[\t ]*)$/) insert_mapfont=1}

/^\(CHARACTER/, /^   \)$/ {
  if (/^\(CHARACTER/) {
    if ($(NF-1)=="C") char_code=cc[$NF]
    else if ($(NF-1)=="O") char_code=ov($NF)
    else if ($(NF-1)=="D") char_code=$NF+0
    else print "! Strange character: " $0
    the_char=$0; sub("CHARACTER", "SETCHAR",the_char); the_char=the_char ")"
  }
  if (/^   \)$/) {
    print "   (MAP"
    if ((DC=="") || (char_code!=DC)) print "      " the_char
    else {was_dummy++} # skip dummy `boundary' char 
    print "      )"
  }
}

{print}

insert_mapfont {
  insert_mapfont=0
  print "(MAPFONT D 0"
  print "   (FONTNAME " font_name ")"
  print "   " check_sum
  print "   (FONTAT R 1.0)"
  print "   " design_size
  print "   )"
}

END {
  if ((was_dummy==0) && (DC!="")) {
    printf("%3d: %s\n", DC,
      "DUMMY CHARACTER NOT FOUND | ZNAK BRZEGOWY NIE ZNALEZIONY") > "CON"
    printf("%3s  %s", "",
      "NO CHANGES MADE           | ZMIAN NIE WPROWADZONO ") > "CON"
    exit(1)
  }
}

function uc(s) {
 for (i=1; i<=length(s); i+=1) {
    ch=substr(s,i,1); if (ch in uc_tab) {gsub(ch,uc_tab[ch],s)}}
 return s
}

function ov(s, d,r) {
  r=0; for (d=1; d<=length(s); d+=1) r=r*8+substr(s,d,1); return r
}

